#define MAXBULLETS 10
#define MESSAGESIZE 1000
struct bullets{
	float xpos;
	float ypos;
	float zpos;
	int type;
	int life;
	float anglex;
	float angley;
	float anglez;
	float viewrx;
	float viewry;
	int hitsomething;
};

struct weapon{
	float speed;
	float cooldowntime;
};
float health=100;
float deaths;
bool firstperson=true;
int team;	
float firsttime=0;
class SShip{
public:
	int currentweapon;
	float xangle;
	float yangle;
	float zangle;
	////////This is to store the network information of each ship. Call ParseInfo to populate these variables.	
	char posx[100];
	char posy[100];
	char posz[100];
	char anglex[100];
	char angley[100];
	char anglez[100];
	float listofinfo[100];
	char sshipnetworkinfo[MESSAGESIZE];
	char rshipnetworkinfo[MESSAGESIZE];
	char tempx[50];
	char tempy[50];
	char tempz[50];
	char tempangle[50];
	char tempangleb[50];
	char tempbulletl[50];
	char temphit[5];
	////////
	char healtht[30];
	float speedx;
	float speedy;
	float speedz;
	float speed;
	float action;
	float top;
	float topturn;
	SShip(GLEngine*shipgraphics,char *shipfile,char *shiptexture,char *shipmultitexture,int textureid,int multitextureid, int objectid);//only one texture per ship right now :-(. Later this function will support more, and shaders, and info for particles systems.
	void DrawShip();
	void DrawNonClientShip();
	void UpDatePostion();
	void ParseInfo();
	void Tokeninze();
	void FireWeapon();
	void DrawBullet();
	bool TestBulletHit(float xb,float yb,float zb);
	bool TestBulletHitGeneral(float xb,float yb,float zb,float xb2,float yb2,float zb2);
	bool TestSphereHitGeneral(float xb,float yb,float zb,float xb2,float yb2,float zb2,float spheresize);
	void SetTeam();
	void DrawTargetArrow();
	weapon weaponstruct[1];
	float targetpx;
	float targetpy;
	////

private:
	SSHip();
	void UpdateWeaponPosition();
	int ido;
	int idt;
	int midt;
	int numberofcommands;
	void TopSpeed();
	bullets bullet[MAXBULLETS];
	GLEngine*SShipgraphics;
	glfireball firebullet;
};
SShip::SShip(GLEngine*shipgraphics,char *shipfile,char *shiptexture,char *shipmultitexture,int textureid,int multitextureid, int objectid )
{
	
	shipgraphics->load3dfile(shipfile,objectid);
	shipgraphics->loadtexture(shiptexture,textureid);
	shipgraphics->loadtexture(shipmultitexture,multitextureid);
	midt=multitextureid;
	ido=objectid;
	idt=textureid;
	xangle=-80;
	yangle=0;
	zangle=0;
	speedx=0;
	speedy=0;
	speedz=0;
	action=0;
	speed=0;
	top=.2;
	topturn=2.0; 
	health=100;
	deaths=0;
	SShipgraphics=shipgraphics;
	numberofcommands=0;
	currentweapon=1;
	weaponstruct[0].speed=.5;
	weaponstruct[0].cooldowntime=5;
	for(int i=0;i<MAXBULLETS;i++)
	{
		bullet[i].type=0;
		bullet[i].anglex=0;
		bullet[i].angley=0;
		bullet[i].anglez=0;
		bullet[i].life=0;
		bullet[i].type=0;
		bullet[i].viewrx=0;
		bullet[i].viewry=0;
		bullet[i].xpos=0;
		bullet[i].ypos=0;
		bullet[i].zpos=0;
		bullet[i].hitsomething=0;
	}
	targetpx=0;
	targetpy=0;
	for(int i2=0;i2<100;i2++)
	{
	listofinfo[i2]=0;
	}
}

void SShip::DrawTargetArrow()
{

	
		SShipgraphics->disableregistercominbers();
		SShipgraphics->disablevertexprograms();
		glDisable(GL_DEPTH_TEST);
		glPushMatrix();
		glLoadIdentity();
		glTranslatef(-7,-7,-15);



		float aside=(-SShipgraphics->Translation.Matrixd[0][3]-listofinfo[0]);
		float oside=(-SShipgraphics->Translation.Matrixd[2][3]-listofinfo[2]);
		float angle=0;
		angle=atan2(oside,aside);
		angle=angle/0.017453292519943295769236907684886;


	 
		glRotatef((angle-90)-SShipgraphics->g_ViewAngle/0.017453292519943295769236907684886,0,1,0);
		SShipgraphics->enablemultitextureunit(0);
		SShipgraphics->selecttexture(13);
		SShipgraphics->enablemultitextureunit(1);
		SShipgraphics->selecttexture(13);
		glColor4f(1,1,1,1);
		SShipgraphics->drawfile(4);
		glPopMatrix();
		glEnable(GL_DEPTH_TEST);
}
void SShip::DrawShip()
{
	glPushMatrix();
	glDisable(GL_LIGHTING);
	glLoadIdentity();
	//glScalef(.0001,.0001,.0001);

	/*glRotatef(xangle,1,0,0);
	glRotatef(zangle,0,1,0);
	glRotatef(yangle,0,0,1);*/


	if(firstperson==false)
	{
	glScalef(.0001,.0001,.0001);
	glTranslatef(0,0,-6000);
	glRotatef(xangle,1,0,0);
	glRotatef(zangle,0,1,0);
	SShipgraphics->enablemultitextureunit(0);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->selecttexture(idt);
	SShipgraphics->enablemultitextureunit(1);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->selecttexture(midt);
	SShipgraphics->enablevertexprograms();
	SShipgraphics->selectvertexprogram(1);
	SShipgraphics->enableregistercombiners();
	SShipgraphics->setupbumpmapping();
	SShipgraphics->drawfile(ido);
	SShipgraphics->disableregistercominbers();
	SShipgraphics->disablevertexprograms();
	SShipgraphics->enablemultitextureunit(0);
	}
	else
	{

	    SShipgraphics->enablemultitextureunit(0);
		SShipgraphics->selecttexture(11);
		SShipgraphics->enablemultitextureunit(1);
		SShipgraphics->selecttexture(11);
		glTranslatef(-.048,-.048,-1);

		SShipgraphics->enableregistercombiners();

		SShipgraphics->alphacut();
		glEnable(GL_ALPHA_TEST);
		glDisable(GL_CULL_FACE);
		glDisable(GL_DEPTH_TEST);
		glAlphaFunc(GL_LESS,1);
		glBegin(GL_QUADS);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,0);
		glVertex3f(0,0,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,0,1);
		glVertex3f(0,.1,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,1);
		glVertex3f(.1,.1,0);
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,1,0);
		glVertex3f(.1,0,0);		
		/////////////
		glVertex3f(0,0,1);	
		/////////
		glEnd();
		glEnable(GL_DEPTH_TEST);
		glEnable(GL_CULL_FACE);
		glDisable(GL_ALPHA_TEST);
		SShipgraphics->disableregistercominbers();
	
	}
	glEnable(GL_LIGHTING);
	
	glPopMatrix();
}
bool SShip::TestBulletHit(float xb,float yb,float zb)
{
	
	vertex amountinter={0,0,0};
	vertex point={xb,yb,zb};
	sphereintersect spherer={-SShipgraphics->Translation.Matrixd[0][3],-SShipgraphics->Translation.Matrixd[1][3],-SShipgraphics->Translation.Matrixd[2][3],.2};
	amountinter=SShipgraphics->checksphereintersection(point,spherer);
	if(fabs(amountinter.x)<spherer.radius&&fabs(amountinter.y)<spherer.radius&&fabs(amountinter.z)<spherer.radius)
	{
		return true;
	}
	else
	{
		return false;
	}
	
}
bool SShip::TestBulletHitGeneral(float xb,float yb,float zb,float xb2,float yb2,float zb2)
{
	
	vertex amountinter={0,0,0};
	vertex point={xb,yb,zb};
	sphereintersect spherer={xb2,yb2,zb2,.2};
	amountinter=SShipgraphics->checksphereintersection(point,spherer);
	if(fabs(amountinter.x)<spherer.radius&&fabs(amountinter.y)<spherer.radius&&fabs(amountinter.z)<spherer.radius)
	{
		return true;
	}
	else
	{
		return false;
	}
	return true;
}
bool SShip::TestSphereHitGeneral(float xb,float yb,float zb,float xb2,float yb2,float zb2,float spheresize)
{
	
	vertex amountinter={0,0,0};
	vertex point={xb,yb,zb};
	sphereintersect spherer={xb2,yb2,zb2,spheresize};
	amountinter=SShipgraphics->checksphereintersection(point,spherer);
	if(fabs(amountinter.x)<spherer.radius&&fabs(amountinter.y)<spherer.radius&&fabs(amountinter.z)<spherer.radius)
	{
		return true;
	}
	else
	{
		return false;
	}
	return true;
}

void SShip::DrawNonClientShip()
{
	
	glPushMatrix();
	glTranslatef(listofinfo[0],listofinfo[1],listofinfo[2]);
	glRotatef(-(listofinfo[4]),0,1,0);
	glRotatef(-(listofinfo[3])+260,1,0,0);
	glRotatef((listofinfo[5]),0,1,0);
	glScalef(.0001,.0001,.0001);
	///
	glDisable(GL_LIGHTING);
	SShipgraphics->enablemultitextureunit(0);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->selecttexture(idt);
	SShipgraphics->enablemultitextureunit(1);
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	SShipgraphics->enablevertexprograms();
	SShipgraphics->selectvertexprogram(1);
	SShipgraphics->enableregistercombiners();
	SShipgraphics->setupbumpmapping();
	SShipgraphics->selecttexture(midt);
	SShipgraphics->drawfile(ido);
	SShipgraphics->disableregistercominbers();
	SShipgraphics->disablevertexprograms();
	SShipgraphics->enablemultitextureunit(0);
	glPopMatrix();
	glEnable(GL_DEPTH_TEST);
	
	int bulletf=0;
	for(int i=6;i<(MAXBULLETS*7)+6;i+=7)//This line did read:for(int i=6;i<(MAXBULLETS*5)+6;i+=5)
	{
		
		if(listofinfo[i+6]==1)
		{
			health-=50;
			deathfactor=.4;
			for(int i2=0;i2<MAXEXP;i2++)
			{
				if(mempool[i2]==0)
				{
					mempool[i2]=1;
					boom[i2].x=listofinfo[i];
					boom[i2].y=listofinfo[i+1];
					boom[i2].z=listofinfo[i+2];
					boom[i2].s=listofinfo[i+3];
					boom[i2].t=listofinfo[i+4];
					i2=MAXEXP;
				}
			}
			
			if(health<0)
			{
			deaths++;
			SetTeam();
			health=100;
			}
		}
		if(listofinfo[i+5]!=0)
		{
			
			glPushMatrix();
			SShipgraphics->selecttexture(4);
			glTranslatef(listofinfo[i],listofinfo[i+1],listofinfo[i+2]);
			glRotatef(listofinfo[i+3],0,1,0);
			glRotatef(listofinfo[i+4],1,0,0);
			firebullet.drawfireball();
			/////////////
			/////////
			glEnd();
			glPopMatrix();
		}
		bulletf++;
		
	}
		glEnable(GL_LIGHTING);
}

void SShip::TopSpeed()
{
	if(speed>top)
	{
		speed=top;
	}
	if(speed<-top)
	{
		speed=-top;
	}
	
}
//////////

//////////////
void SShip::UpDatePostion()
{
/*	float shipx=-SShipgraphics->Translation.Matrixd[0][3];
	float shipy=-SShipgraphics->Translation.Matrixd[1][3];
	float shipz=-SShipgraphics->Translation.Matrixd[2][3];*/
	bool hit=false;
	bool hit2=false;
	hit=TestSphereHitGeneral(-SShipgraphics->Translation.Matrixd[0][3],-SShipgraphics->Translation.Matrixd[1][3],-SShipgraphics->Translation.Matrixd[2][3],(listofinfo[76]*10)+10,(listofinfo[77]*10)+10,(listofinfo[78]*10)+10,1.5);
	hit2=TestSphereHitGeneral(-SShipgraphics->Translation.Matrixd[0][3],-SShipgraphics->Translation.Matrixd[1][3],-SShipgraphics->Translation.Matrixd[2][3],10,10,10,1.9);
	if(hit==true||hit2==true)
	{
	deaths++;
	SetTeam();
	health=100;
	}
//	Translation.Matrixd[0][3]
	

	TopSpeed();
	UpdateWeaponPosition();
	ParseInfo();

}
void SShip::FireWeapon()
{
	int weaponindex=-1;
	///
	for(int i=0;i<MAXBULLETS;i++)
	{
		///
		if(bullet[i].type==0)
		{
			weaponindex=i;
			break;
		}
		////
	}
	//////
	if(weaponindex!=-1)
	{
		bullet[i].type=currentweapon;
		bullet[i].life=0;
		
		
		bullet[i].anglex=-SShipgraphics->Rotation.Matrixd[2][0];
		bullet[i].angley=-SShipgraphics->Rotation.Matrixd[2][1];
		bullet[i].anglez=-SShipgraphics->Rotation.Matrixd[2][2];
		
		bullet[i].viewrx=-SShipgraphics->g_ViewAngle/0.017453292519943295769236907684886;
		bullet[i].viewry=-SShipgraphics->g_ViewAnglez/0.017453292519943295769236907684886;
		
		bullet[i].xpos=-SShipgraphics->Translation.Matrixd[0][3];
		bullet[i].ypos=-SShipgraphics->Translation.Matrixd[1][3];
     	bullet[i].zpos=-SShipgraphics->Translation.Matrixd[2][3];
	
	}
}
void SShip::UpdateWeaponPosition()
{
	for(int i=0;i<MAXBULLETS;i++){
		if(bullet[i].type!=0)
		{
			bullet[i].xpos+=bullet[i].anglex*weaponstruct[bullet[i].type-1].speed;
			bullet[i].ypos+=bullet[i].angley*weaponstruct[bullet[i].type-1].speed;
			bullet[i].zpos+=bullet[i].anglez*weaponstruct[bullet[i].type-1].speed;
			bullet[i].life++;
			if(bullet[i].life>50)
			{
				bullet[i].life=0;
				bullet[i].type=0;
				bullet[i].xpos=0;
				bullet[i].ypos=0;
				bullet[i].zpos=0;
				bullet[i].anglex=0;
				bullet[i].angley=0;
				bullet[i].anglez=0;
				bullet[i].viewrx=0;
				bullet[i].viewry=0;
			}
			if(TestBulletHitGeneral(bullet[i].xpos,bullet[i].ypos,bullet[i].zpos,listofinfo[0],listofinfo[1],listofinfo[2])==true&&bullet[i].life!=0)
			{
				bullet[i].hitsomething=1;
				bullet[i].life=50;
				///
				for(int i2=0;i2<MAXEXP;i2++)
				{
					if(mempool[i2]==0)
					{
						mempool[i2]=1;
						boom[i2].x=bullet[i].xpos;
						boom[i2].y=bullet[i].ypos;
						boom[i2].z=bullet[i].zpos;
						boom[i2].s=bullet[i].viewrx;
						boom[i2].t=bullet[i].viewry;
						i2=MAXEXP;
					}
				}
				///
			}
			
		}
	}
}

void SShip::DrawBullet()
{
	
	for(int i=0;i<MAXBULLETS;i++)
	{
		if(bullet[i].type==1)
		{
			
			glPushMatrix();
			glTranslatef(bullet[i].xpos,bullet[i].ypos,bullet[i].zpos);
			glRotatef(bullet[i].viewrx,0,1,0);
			glRotatef(bullet[i].viewry,1,0,0);
			firebullet.drawfireball();
			glPopMatrix();
			
		}
	}
}
void SShip::SetTeam()
{

	if(firsttime>0)
	{
	deathfactor=1;
	}
	speed=0;
	firsttime=1;
	if(team==1)
	{
		SShipgraphics->move(-10);
	
	}
	else
		if(team==2)
		{
			SShipgraphics->move(10);
			SShipgraphics->turn(180);
		
		}
}


void SShip::ParseInfo()
{
	strcpy(sshipnetworkinfo,"");
	_gcvt(-SShipgraphics->Translation.Matrixd[0][3],20,posx);
	_gcvt(-SShipgraphics->Translation.Matrixd[1][3],20,posy);
	_gcvt(-SShipgraphics->Translation.Matrixd[2][3],20,posz);
	
	/////////
	_gcvt(SShipgraphics->g_ViewAnglez/0.017453292519943295769236907684886,10,anglex);
	_gcvt(SShipgraphics->g_ViewAngle/0.017453292519943295769236907684886,10,angley);
	_gcvt(zangle,10,anglez);
	
	
	strcat(sshipnetworkinfo,posx);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,posy);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,posz);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,anglex);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,angley);
	strcat(sshipnetworkinfo,"x");
	strcat(sshipnetworkinfo,anglez);
	strcat(sshipnetworkinfo,"x");
	for(int i=0;i<MAXBULLETS;i++)
	{
		
		_gcvt(bullet[i].xpos,20,tempx);
		_gcvt(bullet[i].ypos,20,tempy);
		_gcvt(bullet[i].zpos,20,tempz);
		_gcvt(bullet[i].viewrx,20,tempangle);
		_gcvt(bullet[i].viewry,20,tempangleb);
		_gcvt(bullet[i].life,20,tempbulletl);
		_gcvt(bullet[i].hitsomething,20,temphit);
		if(bullet[i].hitsomething==1)
		{
			bullet[i].hitsomething=0;
		}
		strcat(sshipnetworkinfo,tempx);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempy);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempz);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempangle);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempangleb);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,tempbulletl);
		strcat(sshipnetworkinfo,"x");
		strcat(sshipnetworkinfo,temphit);
		strcat(sshipnetworkinfo,"x");
		
	}
	
	
	
	
}
void SShip::Tokeninze()
{
	char * token;
	int indexintofloat=0;
	float temp;
	token = strtok( rshipnetworkinfo, "x" );
	while( token != NULL )
	{
		temp=atof(token);
		
		listofinfo[indexintofloat]=temp;
		indexintofloat++;
		token = strtok( NULL, "x" );
	}
	
	numberofcommands=indexintofloat;
	listofinfo[76]=listofinfo[76];
	listofinfo[77]=listofinfo[77];
	listofinfo[78]=listofinfo[78];
}