/*
Many thanks to Toby Howard(toby@cs.man.ac.uk.) for some of the display code
*/

#include <stdio.h>
clock_t currentTime;  //global variable used to hold the amount of clockticks per second
int previousTime;
float FPS = 0;
int frameCounter; //counts the frames between every second

void printgltext(char *strs,void *font,GLclampf r, GLclampf g, GLclampf b, GLfloat x, GLfloat y)
{
	char *ch; 
  GLint matrixMode;
  GLboolean lightingOn;
  lightingOn= glIsEnabled(GL_LIGHTING);        /* lighting on? */
 if (lightingOn) glDisable(GL_LIGHTING);

 glGetIntegerv(GL_MATRIX_MODE, &matrixMode);  /* matrix mode? */

 glMatrixMode(GL_PROJECTION);
 glPushMatrix();
   glLoadIdentity();
   gluOrtho2D(0.0, 1.0, 0.0, 1.0);
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
     glLoadIdentity();
     glPushAttrib(GL_COLOR_BUFFER_BIT);       /* save current colour */
       glColor3f(r, g, b);
       glRasterPos3f(x, y, 0.0);
       for(ch= strs; *ch; ch++) {
          glutBitmapCharacter(font, (int)*ch);
       }
     glPopAttrib();
   glPopMatrix();
   glMatrixMode(GL_PROJECTION);
 glPopMatrix();
 glMatrixMode(matrixMode);
 if (lightingOn) glEnable(GL_LIGHTING);
}

void fps(void *font, GLclampf r, GLclampf g, GLclampf b, 
              GLfloat x, GLfloat y) {
  /* font: font to use, e.g., GLUT_BITMAP_HELVETICA_10
     r, g, b: text colour
     x, y: text position in window: range [0,0] (bottom left of window)
           to [1,1] (top right of window). */
frameCounter++;

  char str[30]; 
 


 int presentTime;
	currentTime = clock ();
	presentTime = currentTime;
	if ((presentTime - previousTime) / CLOCKS_PER_SEC > 1)
	{
		FPS = (float) frameCounter / ((presentTime - previousTime) /
CLOCKS_PER_SEC);
		frameCounter = 0;
		previousTime = presentTime;
	}


 
  sprintf(str, "Frames per second: %2.0f", FPS);
  printgltext(str,font,r,g,b,x,y);


}


/* end of frames.h */
