/* Copyright (c) Jesse Laeuchli 2000. */
#define MAX_TRUE_FILES 1000
#define SIZEOF_LANDX 128
#define SIZEOF_LANDY 128
#define SPHERESTRIP 300


bool POLYDEBUG=false;
bool snow=false;
#include <gl/glut.h>	
#include <gl/glaux.h>
#include <gl/glext.h>
#include <fstream>
#include <math.h>
#include "datatypes.h"
#include "truespace.h"
#include"spheredata.h"
#include "planetdata.h"
#define numofpart 500
#include "glsnow.h"
typedef float rgbp[3];
float ptexture[SIZEOF_LANDX][SIZEOF_LANDY][4];

//MultiTexture
	PFNGLACTIVETEXTUREARBPROC glActiveTextureARB=NULL;
	PFNGLMULTITEXCOORD2FARBPROC glMultiTexCoord2fARB=NULL;
//Register Combiners
    PFNGLCOMBINERPARAMETERFVNVPROC glCombinerParameterfvNV;
    PFNGLCOMBINERPARAMETERFNVPROC glCombinerParameterfNV;
    PFNGLCOMBINERPARAMETERIVNVPROC glCombinerParameterivNV;
    PFNGLCOMBINERPARAMETERINVPROC glCombinerParameteriNV;
    PFNGLCOMBINERINPUTNVPROC glCombinerInputNV;
    PFNGLCOMBINEROUTPUTNVPROC glCombinerOutputNV;
    PFNGLFINALCOMBINERINPUTNVPROC glFinalCombinerInputNV;
//Vertex Programs
	PFNGLBINDPROGRAMNVPROC glBindProgramNV;
	PFNGLDELETEPROGRAMSNVPROC glDeleteProgramsNV;
	PFNGLEXECUTEPROGRAMNVPROC glExecuteProgramNV;
	PFNGLGENPROGRAMSNVPROC glGenProgramsNV;
	PFNGLLOADPROGRAMNVPROC glLoadProgramNV;
	PFNGLTRACKMATRIXNVPROC glTrackMatrixNV;
	PFNGLPROGRAMPARAMETER4FNVPROC glProgramParameter4fNV;
								
	

void setupcombiners()
{
	glCombinerParameterfvNV=(PFNGLCOMBINERPARAMETERFVNVPROC)wglGetProcAddress("glCombinerParameterfvNV");
    glCombinerParameterfNV=(PFNGLCOMBINERPARAMETERFNVPROC)wglGetProcAddress( "glCombinerParameterfNV");
    glCombinerParameterivNV=(PFNGLCOMBINERPARAMETERIVNVPROC)wglGetProcAddress( "glCombinerParameterivNV");
    glCombinerParameteriNV=(PFNGLCOMBINERPARAMETERINVPROC)wglGetProcAddress( "glCombinerParameteriNV");
    glCombinerInputNV=(PFNGLCOMBINERINPUTNVPROC)wglGetProcAddress( "glCombinerInputNV");
    glCombinerOutputNV=(PFNGLCOMBINEROUTPUTNVPROC)wglGetProcAddress( "glCombinerOutputNV");
    glFinalCombinerInputNV=(PFNGLFINALCOMBINERINPUTNVPROC)wglGetProcAddress( "glFinalCombinerInputNV");
}
void setuptext()
{
	glActiveTextureARB = (PFNGLACTIVETEXTUREARBPROC)
        wglGetProcAddress("glActiveTextureARB");
    glMultiTexCoord2fARB = (PFNGLMULTITEXCOORD2FARBPROC)
        wglGetProcAddress("glMultiTexCoord2fARB");
}

void setupvertexp()
{
	glBindProgramNV = (PFNGLBINDPROGRAMNVPROC) wglGetProcAddress("glBindProgramNV");
	glDeleteProgramsNV = (PFNGLDELETEPROGRAMSNVPROC) wglGetProcAddress("glDeleteProgramsNV");
	glExecuteProgramNV = (PFNGLEXECUTEPROGRAMNVPROC) wglGetProcAddress("glExecuteProgramNV");
	glGenProgramsNV = (PFNGLGENPROGRAMSNVPROC) wglGetProcAddress("glGenProgramsNV");
	glLoadProgramNV = (PFNGLLOADPROGRAMNVPROC) wglGetProcAddress("glLoadProgramNV");
	glTrackMatrixNV = (PFNGLTRACKMATRIXNVPROC) wglGetProcAddress("glTrackMatrixNV");
	glProgramParameter4fNV=(PFNGLPROGRAMPARAMETER4FNVPROC)wglGetProcAddress("glProgramParameter4fNV");
}

void combinercode()
{
	float color[]={ 1,1,1,1};
	glCombinerParameteriNV(GL_NUM_GENERAL_COMBINERS_NV, 2);
	glCombinerParameterfvNV(GL_CONSTANT_COLOR0_NV, color);
	/////
glCombinerInputNV(GL_COMBINER0_NV, GL_ALPHA, GL_VARIABLE_A_NV, 
     GL_TEXTURE0_ARB, GL_SCALE_BY_FOUR_NV, GL_ALPHA);

glCombinerInputNV(GL_COMBINER0_NV, GL_ALPHA, GL_VARIABLE_B_NV, 
     GL_PRIMARY_COLOR_NV,GL_SCALE_BY_FOUR_NV, GL_ALPHA);
////////////////
glCombinerOutputNV(GL_COMBINER0_NV, GL_ALPHA, GL_SPARE0_NV, GL_DISCARD_NV, 
     GL_DISCARD_NV, GL_NONE, GL_NONE, GL_FALSE, GL_FALSE, GL_FALSE);
////////// Dot3 lighting can also be done here.


glCombinerInputNV(GL_COMBINER1_NV, GL_ALPHA, GL_VARIABLE_A_NV, 
     GL_ZERO, GL_SIGNED_IDENTITY_NV, GL_ALPHA);
//////////////
glCombinerInputNV(GL_COMBINER1_NV, GL_ALPHA, GL_VARIABLE_B_NV, 
     GL_ZERO,GL_SIGNED_IDENTITY_NV, GL_ALPHA);
/////////////////////
glCombinerInputNV(GL_COMBINER1_NV, GL_ALPHA, GL_VARIABLE_C_NV, 
     GL_CONSTANT_COLOR0_NV, GL_SIGNED_IDENTITY_NV, GL_ALPHA);

glCombinerInputNV(GL_COMBINER1_NV, GL_ALPHA, GL_VARIABLE_D_NV, 
     GL_TEXTURE0_ARB, GL_SIGNED_IDENTITY_NV, GL_ALPHA);
////////////////

glCombinerOutputNV(GL_COMBINER1_NV, GL_ALPHA, GL_DISCARD_NV, GL_DISCARD_NV, 
     GL_SPARE0_NV, GL_NONE, GL_NONE, GL_FALSE, GL_FALSE, GL_TRUE);
		
	///
	//////////Should Be working by now :-)....
	
}
class GLEngine{
private:
	int width,hight;
	ReadSCNFile *pToTrue[MAX_TRUE_FILES];
	AUX_RGBImageRec *TextureImage[500];
	GLuint	texturest[500];//space for 500 textures
	GLuint	vertexprogram[500];//No one needs more then this right?
	GLEngine();
	vertex planet[29400];
	vertex hope[(SIZEOF_LANDX*SIZEOF_LANDY*2)*3];//memory allocated for landscape....
	vertex normals[(SIZEOF_LANDX*SIZEOF_LANDY)*2];
	vertex normals2[SIZEOF_LANDX][SIZEOF_LANDY*2];
	float textureu[4560];
	float texturev[4560];
	int escape;
	void mfractalg();
	void landcolor(float zc);
	vertex calcuatenormals(vertex vertex1,vertex vertex2,vertex vertex3);
	char * openprogram(char * filename);
	void landnormal(int x);
	double Mand(double initx, double inity, unsigned int iterations);
	vertex multiplybymatrix(Matrix multim,vertex vector);
	float recallangle;
	int cx;
	int cy;
	int lasttextidused;
	int lastobjectidused;
	void CreateArray();
	float arraydata[29400*3];
	float texdata[29400*2];
public:
	double eyeVX;
	double eyeVY;
	double eyeVZ;
	vertex RTU(vertex vertex1);
	vertex lookDir;
	vertex eye;
	vertex orientation;
	float g_ViewAngle;
	float g_ViewAnglez;
	float mf[SIZEOF_LANDX][SIZEOF_LANDY];
	float mf1d[SIZEOF_LANDX];
	float skytexture[SIZEOF_LANDX][SIZEOF_LANDY][4];
	float seatexture[SIZEOF_LANDX][SIZEOF_LANDY][4];
	float daylight;
	float foggy;
	float fogColor[4]; 
	GLEngine(void ( * render)(void),int width,int hight,bool fullscreen);
	~GLEngine();
	void load3dfile(char *filename,int indextot);
	void unload3dfile(int indextot);
	void drawfile(int indextot);
	void mainloop();
	void readfractal(int howx,int howy,char *whichhieghtmap);
	void readfractal1d(int howx,char *whichhieghtmap);
	void enablemultitextureunit(int textureunit=0);
	void loadtexture(char * texture,int currentt);
	void loadptexture(float ptexture[SIZEOF_LANDX][SIZEOF_LANDY][4],int currentt);
	void disablemultitextureunit(int textureunit=1);
	void drawland(int indextot);
	void drawfog();
	snowp snow;
	void drawsnow();
	void setuplight(float *sl,float *al,float *dl,float *pos);
	void setupland(int howbigx,int howbigy,int indextot,char *whichhieghtmap);
	void setupplanet(int howbigx,int howbigy,int indextot,char *whichhieghtmap);
	vertex checksphereintersection(vertex checktothisposition,sphereintersect intersectiontocheck);
	void selecttexture(int selectt);
	void drawsky();
	void drawsea();
	void createskyformfractal();
	void creategrassfromfractal();
	void createsea();
	void turn(float x);
	void move(float x);
	void climb(float x);
	void lookup(float x);
	void updatecamera();
	void enablevertexprograms();
	void disablevertexprograms();
	void enableregistercombiners();
	void disableregistercominbers();
	void setupbumpmapping();
	void loadvertexprogram(int id, char *filename);
	void selectvertexprogram(int selectp);
	fstream file;
	fstream file2;
};
GLEngine::~GLEngine()
{
	
}

GLEngine::GLEngine(void ( * render)(void),int width,int hight,bool fullscreen)
{	

	recallangle=0;
	g_ViewAngle=(180*0.017453292519943295769236907684886);//Do I have enough accuarcy yet?
	g_ViewAnglez=(180*0.017453292519943295769236907684886);
	eyeVX=0;
	eyeVY=0;
	eyeVZ=0;
	foggy=0;	
	fogColor[0]=.5;
	fogColor[1]=.5;
	fogColor[2]=.5;
	fogColor[3]=1;
	lookDir.x=0;
	lookDir.y=0;
	lookDir.z=0;
	orientation.x=0;
	orientation.y=1;
	orientation.z=0;
	eye.x=0;
	eye.y=0;
	eye.z=0;
	cx=0;
	cy=0;
	file2.open("test.raw",ios::out);//Used to debug.
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGBA|GLUT_DEPTH|GLUT_ALPHA);

	glutInitWindowPosition(0,0);
	glutInitWindowSize(width,hight);
	glutCreateWindow("GLEngine");;
//	glutGameModeString("1600x1200:16");
//	glutEnterGameMode();
	if(fullscreen==true)
	{
	glutFullScreen();
	}
	GLfloat fAspect=width/hight;
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(60,fAspect,0.4,400.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_COLOR_MATERIAL);
	daylight=1;
	glutDisplayFunc(render);
	glutKeyboardFunc(Key);
	glutSpecialFunc(funcs); 
	glutSpecialUpFunc(funcs2);	
	glutIdleFunc(setupdisplay);
	glutTimerFunc(300,timerfunction,1);
	setuptext();
	setupcombiners();
	setupvertexp();
	enablemultitextureunit(0);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);


	
}
void GLEngine::drawfog()
{
	glFogi(GL_FOG_MODE,GL_EXP2);		// Fog Mode
	glFogfv(GL_FOG_COLOR, fogColor);			// Set Fog Color
	glFogf(GL_FOG_DENSITY, foggy);				// How Dense Will The Fog Be
	glHint(GL_FOG_HINT, GL_NICEST );			// Fog Hint Value
	glFogf(GL_FOG_START, 1.0f);				// Fog Start Depth
	glFogf(GL_FOG_END, 5.0f);				// Fog End Depth
	glEnable(GL_FOG);
}
void GLEngine::mainloop()
{
	glutMainLoop();
}
void GLEngine::load3dfile(char *filename,int indextot )
{
	pToTrue[indextot]=new ReadSCNFile(filename);
	int ran=0;
	int runit=0;
	
	
	glNewList(indextot+1,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_TRIANGLES );
	for(int i=0;i<pToTrue[indextot]->vertexccount;i++)
	{
		for(int i2=2;i2<pToTrue[indextot]->VERTEXC[runit];i2++)
		{
			int temp=ran;
			int norm1=temp;
			int norm2=(i2-1)+ran;
			int norm3=(i2)+ran;
			////Optimized for T&L cards.
			/*vertex normal;
			normal=calcuatenormals(pToTrue[indextot]->pVertex[norm1],pToTrue[indextot]->pVertex[norm2],pToTrue[indextot]->pVertex[norm3]);
			normal=RTU(normal);
			glNormal3f(normal.x,normal.y,normal.z);*/
			////
			//glColor3f(0,1,1);
		//	glNormal3f(pToTrue[indextot]->pVertex[temp].x,pToTrue[indextot]->pVertex[temp].y,pToTrue[indextot]->pVertex[temp].z);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,pToTrue[indextot]->pVertex[temp].u,pToTrue[indextot]->pVertex[temp].v);
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pToTrue[indextot]->pVertex[temp].u,pToTrue[indextot]->pVertex[temp].v);
			glVertex3f(pToTrue[indextot]->pVertex[temp].x,pToTrue[indextot]->pVertex[temp].y,pToTrue[indextot]->pVertex[temp].z);
			temp=(i2-1)+ran;
			///
			/*
			norm1=temp;
			norm2=(i2-1)+ran+1;
			norm3=(i2)+ran+1;
			normal=calcuatenormals(pToTrue[indextot]->pVertex[norm1],pToTrue[indextot]->pVertex[norm2],pToTrue[indextot]->pVertex[norm3]);
			normal=RTU(normal);
			glNormal3f(normal.x,normal.y,normal.z);*/
			///
		//	glNormal3f(pToTrue[indextot]->pVertex[temp].x,pToTrue[indextot]->pVertex[temp].y,pToTrue[indextot]->pVertex[temp].z);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,pToTrue[indextot]->pVertex[temp].u,pToTrue[indextot]->pVertex[temp].v);
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pToTrue[indextot]->pVertex[temp].u,pToTrue[indextot]->pVertex[temp].v);
			glVertex3f(pToTrue[indextot]->pVertex[temp].x,pToTrue[indextot]->pVertex[temp].y,pToTrue[indextot]->pVertex[temp].z);
			temp=(i2)+ran;
		//
		/*	norm1=temp;
			norm2=(i2-1)+ran-1;
			norm3=(i2)+ran-1;
			normal=calcuatenormals(pToTrue[indextot]->pVertex[norm1],pToTrue[indextot]->pVertex[norm2],pToTrue[indextot]->pVertex[norm3]);
			normal=RTU(normal);
			glNormal3f(normal.x,normal.y,normal.z);*/
			//
		//	glNormal3f(pToTrue[indextot]->pVertex[temp].x,pToTrue[indextot]->pVertex[temp].y,pToTrue[indextot]->pVertex[temp].z);
			glMultiTexCoord2fARB(GL_TEXTURE0_ARB,pToTrue[indextot]->pVertex[temp].u,pToTrue[indextot]->pVertex[temp].v);
			glMultiTexCoord2fARB(GL_TEXTURE1_ARB,pToTrue[indextot]->pVertex[temp].u,pToTrue[indextot]->pVertex[temp].v);
			glVertex3f(pToTrue[indextot]->pVertex[temp].x,pToTrue[indextot]->pVertex[temp].y,pToTrue[indextot]->pVertex[temp].z);
		
		}
		ran+=pToTrue[indextot]->VERTEXC[runit];
		runit++;
	}
	
	glEnd();
	
	glEndList();
	
	//openraw(filename);
}
void GLEngine::unload3dfile(int indextot)
{
	delete pToTrue[indextot];
}
vertex GLEngine::checksphereintersection(vertex checktothisposition,sphereintersect intersectiontocheck)
{
	vertex amountofintersection;

	amountofintersection.x=checktothisposition.x-intersectiontocheck.x;
	amountofintersection.y=checktothisposition.y-intersectiontocheck.y;
	amountofintersection.z=checktothisposition.z-intersectiontocheck.z;

	return amountofintersection;
}
void GLEngine::drawfile(int indextot)
{
	
	glBegin(GL_TRIANGLES );
	glCallList(indextot+1);
	glEnd();	  //renderfile(whichfile);
}
void GLEngine::loadtexture(char *texture,int currentt)
{
	TextureImage[currentt]=auxDIBImageLoad(texture);
	//texturest[currentt]=new GLuint;
	glGenTextures(1,&texturest[currentt]);
	glBindTexture(GL_TEXTURE_2D, texturest[currentt]);
	glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[currentt]->sizeX, TextureImage[currentt]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[currentt]->data);
	//
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
	free(TextureImage[currentt]->data);
	free(TextureImage[currentt]);	
}
void GLEngine::loadptexture(float ptexture[SIZEOF_LANDX][SIZEOF_LANDY][4],int currentt)
{
	glGenTextures(currentt,&texturest[currentt]);
	glBindTexture(GL_TEXTURE_2D, texturest[currentt]);
	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, SIZEOF_LANDX, SIZEOF_LANDY, 0, GL_RGBA, GL_FLOAT, ptexture);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);	// Linear Filtering
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
}

void GLEngine::enablemultitextureunit(int textureunit)
{
	if(textureunit==0)
	{
		glActiveTextureARB(GL_TEXTURE0_ARB);
		glEnable(GL_TEXTURE_2D);
	}
	else
	if(textureunit==1)
	{
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glEnable(GL_TEXTURE_2D);
	}
	else
	if(textureunit==2)
	{
		glActiveTextureARB(GL_TEXTURE2_ARB);
		glEnable(GL_TEXTURE_2D);
	}
}


void GLEngine::disablemultitextureunit(int textureunit)
{
	if(textureunit==1)
	{
		glActiveTextureARB(GL_TEXTURE1_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTextureARB(GL_TEXTURE0_ARB);
	}
	else
	if(textureunit==2)
	{
		glActiveTextureARB(GL_TEXTURE2_ARB);
		glDisable(GL_TEXTURE_2D);
		glActiveTextureARB(GL_TEXTURE0_ARB);
	}

}

double GLEngine::Mand (double initx, double inity, unsigned int iterations) {
    
    double cx,cy,xsq,ysq;
    double iter;
    
    cx=initx+initx*initx - inity*inity;   
    cy=inity+initx*inity+initx*inity; 
    
    for (iter=0;iter<iterations && (ysq=cy*cy)+(xsq=cx*cx)<4;iter++,cy=inity+cx*cy+cx*cy,cx=initx-ysq+xsq) ;
    return (iter);
}
void GLEngine::mfractalg()
{
	file2.open("test2.raw",ios::out);
	int idicesx=0;
	int idicesy=0;
	float seedx=0;
	float seedy=0;
	int changey=0;
	for(int i=0;i<1089;i++)
	{
		seedx-=(rand()%1000)/100;
		if(changey==33)
		{
			seedy-=(rand()%1000)/100;
		}
		double test=Mand(seedx,seedy,20000);
		mf[idicesx][idicesy]=test;
		file2<<test<<endl;
		idicesx++;
		if(idicesx==33)
		{
			idicesx=0;
			idicesy++;
		}
		changey++;
	}
}
void GLEngine::readfractal(int howx,int howy,char *whichhieghtmap)
{
	fstream file3;
	file3.open(whichhieghtmap,ios::in);
	for(int y=0;y<howx;y++)
		for(int x=0;x<howy;x++)
		{
			float it=0;
			file3>>it;
			if(it>0)
			{
				mf[y][x]=(it);
			}
			else
			{
				mf[y][x]=0;
			}
		}
		//
}
void GLEngine::readfractal1d(int howx,char *whichhieghtmap)
{
fstream file;
float it=0;
file.open(whichhieghtmap,ios::in);
for(int x=0;x<howx;x++)
{
file>>it;
mf1d[x]=it;
}
}

void GLEngine::landnormal(int x)
{
	
	vertex normal;
	normal=calcuatenormals(hope[x],hope[x+1],hope[x+2]);
	normal=RTU(normal);
	glNormal3f(normal.x,normal.y,normal.z);
	//glNormal3f(0,-1,0);
}
void GLEngine::setupland(int howbigx,int howbigy,int indextot,char *whichhieghtmap)
{
	///
	//mfractalg();
	readfractal(howbigx,howbigy,whichhieghtmap);
	vertex test[6]={0,1,1,0,0, 1,0,1,0,0, 0,0,1,0,0, 1,1,1,0,0, 1,0,1,0,0, 0,1,1,0,0 };
	int starti=0;
	float addto=1;
	float addtoy=0;
	int mfix=0;
	int mfiy=0;
	//
	int howbigx2=65*2;
	int addto2=0;
	int addtoy2=0; 
	
	for(int i2=0;i2<SIZEOF_LANDX*SIZEOF_LANDY;i2++)
	{
		hope[starti].x=test[0].x+addto;
		hope[starti].y=test[0].y+addtoy;
		hope[starti].z=mf[mfix][mfiy+1];
		///
		starti++;
		hope[starti].x=test[1].x+addto;
		hope[starti].y=test[1].y+addtoy;
		hope[starti].z=mf[mfix+1][mfiy];
		///
		starti++;
		hope[starti].x=test[2].x+addto;
		hope[starti].y=test[2].y+addtoy;
		hope[starti].z=mf[mfix][mfiy];
		///
		starti++;
		hope[starti].x=test[3].x+addto;
		hope[starti].y=test[3].y+addtoy;
		hope[starti].z=mf[mfix+1][mfiy+1];
		///
		starti++;
		hope[starti].x=test[4].x+addto;
		hope[starti].y=test[4].y+addtoy;
		hope[starti].z=mf[mfix+1][mfiy];
		///
		starti++;
		hope[starti].x=test[5].x+addto;
		hope[starti].y=test[5].y+addtoy;
		hope[starti].z=mf[mfix][mfiy+1];
		///
		starti++;
		addto+=1;
		///
		normals2[addtoy2][addto2]=RTU(calcuatenormals(hope[starti-6],hope[starti-5],hope[starti-4]));
		addto2+=1;
		normals2[addtoy2][addto2]=RTU(calcuatenormals(hope[starti-3],hope[starti-2],hope[starti-1]));
		///
		mfix++;
		if(howbigx==addto)
		{
			addtoy+=1;
			mfix=0;
			mfiy++;
			addto=1;
		}
		if(howbigx2==addto2)
		{
			addtoy2+=1;
			addto2=-1;
		}
		addto2+=1;
	}
	int onedindex=0;
	for(int y=0;y<SIZEOF_LANDY;y++)
	{
		for(int x=0;x<SIZEOF_LANDX*2;x++)
		{
			vertex temp;
			temp.x=(normals2[y][x].x+normals2[y+1][x].x+normals2[y-1][x].x+normals2[y][x+1].x+normals2[y][x-1].x+normals2[y+1][x+1].x+normals2[y+1][x-1].x+normals2[y-1][x-1].x+normals2[y-1][x+1].x
				+normals2[y+2][x].x+normals2[y-2][x].x+normals2[y][x+2].x+normals2[y][x-2].x+normals2[y+2][x+2].x+normals2[y+2][x-2].x+normals2[y-2][x-2].x+normals2[y-2][x+2].x)/17;
			temp.y=(normals2[y][x].y+normals2[y+1][x].y+normals2[y-1][x].y+normals2[y][x+1].y+normals2[y][x-1].y+normals2[y+1][x+1].y+normals2[y+1][x-1].y+normals2[y-1][x-1].y+normals2[y-1][x+1].y
				+normals2[y+2][x].y+normals2[y-2][x].y+normals2[y][x+2].y+normals2[y][x-2].y+normals2[y+2][x+2].y+normals2[y+2][x-2].y+normals2[y-2][x-2].y+normals2[y-2][x+2].y)/17;
			temp.z=(normals2[y][x].z+normals2[y+1][x].z+normals2[y-1][x].z+normals2[y][x+1].z+normals2[y][x-1].z+normals2[y+1][x+1].z+normals2[y+1][x-1].z+normals2[y-1][x-1].z+normals2[y-1][x+1].z
				+normals2[y+2][x].z+normals2[y-2][x].z+normals2[y][x+2].z+normals2[y][x-2].z+normals2[y+2][x+2].z+normals2[y+2][x-2].z+normals2[y-2][x-2].z+normals2[y-2][x+2].z)/17;
			normals[onedindex]=RTU(temp);
			onedindex++;
		}
	}
	//file.open("test.raw",ios::out);
	int q=0;
	glNewList(indextot+1,GL_COMPILE_AND_EXECUTE);
	glBegin(GL_TRIANGLES);
	for(int i=0;i<SIZEOF_LANDX*SIZEOF_LANDY*2;i++)
	{
		if(cx<SIZEOF_LANDX)
		{
			cx++;
		}
		else
		{
			cy++;
			cx=0;
		}
		//file<<hope[q].x<<","<<hope[q].y<<","<<hope[q].z<<"\n";
		//landnormal(q);
		//glNormal3f(0,-1,0);
		glNormal3f(normals[i].x,normals[i].y,normals[i].z);
		landcolor(hope[q].z);
		glVertex3f(hope[q].x/10,hope[q].y/10,hope[q].z/10);
		glTexCoord2f(hope[q].x/10,hope[q].y/10);//I know you are supposed to set the tex choord before the vertex, but this looks better(more random). Once I figure out how to texture map terrians, I'll change it..
		q++;
		//file<<hope[q].x<<","<<hope[q].y<<","<<hope[q].z<<"\n";
		landcolor(hope[q].z);
		glNormal3f(normals[i+1].x,normals[i+1].y,normals[i+1].z);
		glVertex3f(hope[q].x/10,hope[q].y/10,hope[q].z/10);
		glTexCoord2f(hope[q].x/10,hope[q].y/10);
		q++;
		//file<<hope[q].x<<","<<hope[q].y<<","<<hope[q].z<<"\n";
		landcolor(hope[q].z);
		glNormal3f(normals[i-1].x,normals[i-1].y,normals[i-1].z);
		glVertex3f(hope[q].x/10,hope[q].y/10,hope[q].z/10);
		glTexCoord2f(hope[q].x/10,hope[q].y/10);
		q++;
	}
	glEnd();
	glEndList();
	//
	//
	
}
void GLEngine::setupplanet(int howbigx,int howbigy,int indextot,char *whichieghtmap)
{
	for(int y11=0;y11<SIZEOF_LANDY;y11++)
	for(int x11=0;x11<SIZEOF_LANDX;x11++)
	{
	mf[y11][x11]=0;
	}
	fstream file;
	file.open(whichieghtmap,ios::in);
	for(int yy=0;yy<howbigy;yy++)
		for(int xx=0;xx<howbigx;xx++)
		{
			float it=0;
			file>>it;
			if(it==0)
			{
				it=2;
			}
			mf[xx][yy]=2+((it/200));
		}
		/*
		mf[0][0]=mf[0][(SPHERESTRIP/3)-1];
		mf[0][1]=mf[0][SPHERESTRIP/3];
		mf[SPHERESTRIP/3][1]=mf[0][SPHERESTRIP/3];
		mf[0][SPHERESTRIP/12]=mf[SPHERESTRIP/3][SPHERESTRIP/12];
		mf[SPHERESTRIP/3][(SPHERESTRIP/12)+1]=mf[(SPHERESTRIP/12)][SPHERESTRIP/3];*/
		/////////////////
		for(int ind=0;ind<howbigy;ind++)
		{
		mf[howbigx-1][ind]=mf[0][ind];
		}
		int mfix=0;
		int mfiy=0;
		int starti=SPHERESTRIP;
		int capi=0;
		int hieghti=0;
		for(int a=0;a<SPHERESTRIP/3;a++)
		{
			planet[capi].x=sphere2[capi].x*mf[hieghti][0];
			planet[capi].y=sphere2[capi].y*mf[hieghti][0];
			planet[capi].z=sphere2[capi].z*mf[hieghti][0];
			capi++;
			planet[capi].x=sphere2[capi].x*mf[0][0];
			planet[capi].y=sphere2[capi].y*mf[0][0];
			planet[capi].z=sphere2[capi].z*mf[0][0];
			capi++;
			planet[capi].z=sphere2[capi].z*mf[hieghti+1][0];
			planet[capi].x=sphere2[capi].x*mf[hieghti+1][0];
			planet[capi].y=sphere2[capi].y*mf[hieghti+1][0];
			hieghti++;
			capi++;
			
		}
		for(int i=0;i<4800;i++)
		{
			
			planet[starti].x=sphere2[starti].x*mf[mfix+1][mfiy+1];
			planet[starti].z=sphere2[starti].z*mf[mfix+1][mfiy+1];
			planet[starti].y=sphere2[starti].y*mf[mfix+1][mfiy+1];
			///
			starti++;
			planet[starti].x=sphere2[starti].x*mf[mfix][mfiy+1];
			planet[starti].z=sphere2[starti].z*mf[mfix][mfiy+1];
			planet[starti].y=sphere2[starti].y*mf[mfix][mfiy+1];
			///
			
			starti++;
			planet[starti].x=sphere2[starti].x*mf[mfix][mfiy];
			planet[starti].z=sphere2[starti].z*mf[mfix][mfiy];
			planet[starti].y=sphere2[starti].y*mf[mfix][mfiy];//done
			///
			starti++;
			planet[starti].x=sphere2[starti].x*mf[mfix][mfiy];
			planet[starti].z=sphere2[starti].z*mf[mfix][mfiy];
			planet[starti].y=sphere2[starti].y*mf[mfix][mfiy];//done
			
			starti++;
			planet[starti].x=sphere2[starti].x*mf[mfix+1][mfiy];
			planet[starti].z=sphere2[starti].z*mf[mfix+1][mfiy];
			planet[starti].y=sphere2[starti].y*mf[mfix+1][mfiy];//done
			///
			starti++;
			planet[starti].x=sphere2[starti].x*mf[mfix+1][mfiy+1];
			planet[starti].z=sphere2[starti].z*mf[mfix+1][mfiy+1];
			planet[starti].y=sphere2[starti].y*mf[mfix+1][mfiy+1];
			starti++;
			mfix++;
			if(mfix==(SPHERESTRIP/3))
			{
				mfiy++;
				mfix=0;
			}
			
		}
		capi=starti;
		hieghti=0;
		
		for(int a2=0;a2<SPHERESTRIP/3;a2++)
		{
			planet[capi].z=sphere2[capi].z*mf[0][mfiy];
			planet[capi].y=sphere2[capi].y*mf[0][mfiy];
			planet[capi].x=sphere2[capi].x*mf[0][mfiy];
			capi++;
			planet[capi].z=sphere2[capi].z*mf[hieghti][mfiy];
			planet[capi].y=sphere2[capi].y*mf[hieghti][mfiy];
			planet[capi].x=sphere2[capi].x*mf[hieghti][mfiy];
			capi++;
			planet[capi].z=sphere2[capi].z*mf[hieghti+1][mfiy];
			planet[capi].x=sphere2[capi].x*mf[hieghti+1][mfiy];
			planet[capi].y=sphere2[capi].y*mf[hieghti+1][mfiy];
			hieghti++;
			capi++;
		}
		///
		CreateArray();
	
		////////////
		glEnableClientState(GL_TEXTURE_COORD_ARRAY);
		glTexCoordPointer(2,GL_FLOAT,0,(void *)texdata);
		glEnableClientState(GL_VERTEX_ARRAY);	
		glVertexPointer(3,GL_FLOAT,0,(void *)arraydata);
		/////////////////
		glNewList(indextot+1,GL_COMPILE_AND_EXECUTE);
		glDrawArrays(GL_TRIANGLES,0,29400);
		glEndList();
}
void GLEngine::CreateArray()
{	int arrayindex=0;
	int arrayindex2=0;
	for(int i=0;i<29400;i++)
	{
		arraydata[arrayindex]=planet[i].x;
		arrayindex++;
		arraydata[arrayindex]=planet[i].y;
		arrayindex++;
		arraydata[arrayindex]=planet[i].z;
		arrayindex++;
		///////
		texdata[arrayindex2]=sphere2[i].u;
		arrayindex2++;
		texdata[arrayindex2]=sphere2[i].v;
		arrayindex2++;
	
	}
}

void GLEngine::drawland(int indextot)
{

	glBegin(GL_TRIANGLES );
	glCallList(indextot+1);
	glEnd();

}
void GLEngine::selecttexture(int selectt)
{
	glBindTexture(GL_TEXTURE_2D, texturest[selectt]);
}
void GLEngine::landcolor(float zc)
{
	if(zc>4)
	{
		glColor3f(1,1,1);
	}
	/*else
	if(zc<-4)
	{
	glColor3f(0,0,1);
}*/
	else
	{
		glColor3f(0,.6,0);
	}
	///
}

void GLEngine::drawsnow()
{
	glDisable(GL_LIGHTING);
	glBegin(GL_QUADS);
	glColor4f(1,1,1,1);
	for(int i=0;i<numofpart;i++)
	{
		glVertex3f(snow.prt[i].xp,snow.prt[i].yp,snow.prt[i].zp);
		glVertex3f(snow.prt[i].xp+.009,snow.prt[i].yp,snow.prt[i].zp);
		glVertex3f(snow.prt[i].xp,snow.prt[i].yp+.009,snow.prt[i].zp);
		glVertex3f(snow.prt[i].xp+.009,snow.prt[i].yp+.009,snow.prt[i].zp);
	}
	glEnd();
	glEnable(GL_LIGHTING);
	
}
///Lighting stuff. This is unoptimized code just using the OpenGL libary. Better proformance would result if I wrote my own lighting code(at least on todays cards, newer cards support T&L that would make this run faster).
void GLEngine::setuplight(float *sl,float *al,float *dl,float *pos)
{
	glLightfv(GL_LIGHT0,GL_DIFFUSE,dl);
	glLightfv(GL_LIGHT0,GL_POSITION,pos);
	//glLightfv(GL_LIGHT0,GL_AMBIENT,al);
	//glLightfv(GL_LIGHT0,GL_SPECULAR,al);
	//glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
	////glMaterialfv(GL_FRONT,GL_SPECULAR,al);
	//glMateriali(GL_FRONT,GL_SHININESS,128);
}
vertex GLEngine::calcuatenormals(vertex vertex1,vertex vertex2,vertex vertex3)
{
	vertex normal;
	float vector1[3],vector2[3];
	vector1[0]=vertex2.x-vertex1.x;
	vector1[1]=vertex2.y-vertex1.y;
	vector1[2]=vertex2.z-vertex1.z;
	//
	vector2[0]=vertex3.x-vertex1.x;
	vector2[1]=vertex3.y-vertex1.y;
	vector2[2]=vertex3.z-vertex1.z;
	//
	normal.x=vector1[1]*vector2[2]-vector1[2]*vector2[1];
	normal.y=vector1[2]*vector2[0]-vector1[0]*vector2[2];
	normal.z=vector1[0]*vector2[1]-vector1[1]*vector2[0];
	return normal;
}
vertex GLEngine::RTU(vertex vertex1)
{
	float length;
	
	// Calculate the length of the vector		
	length = (float)sqrt((vertex1.x*vertex1.x) + 
		(vertex1.y*vertex1.y) +
		(vertex1.z*vertex1.z));
	
	// Keep the program from blowing up by providing an exceptable
	// value for vectors that may calculated too close to zero.
	if(length == 0.0f)
		length = 1.0f;
	
	// Dividing each element by the length will result in a
	// unit normal vector.
	vertex1.x /= length;
	vertex1.y /= length;
	vertex1.z/= length;
	return vertex1;
}
//This code is for Per Pixel Lighting. Requires a Geforce Card to run but looks ALOT better.
///
void GLEngine::setupbumpmapping()
{
	glCombinerParameteriNV(GL_NUM_GENERAL_COMBINERS_NV, 1);
    glCombinerInputNV(GL_COMBINER0_NV, GL_RGB, GL_VARIABLE_A_NV, GL_TEXTURE0_ARB, GL_EXPAND_NORMAL_NV, GL_RGB);
	glCombinerInputNV(GL_COMBINER0_NV, GL_RGB, GL_VARIABLE_B_NV, GL_PRIMARY_COLOR_NV, GL_EXPAND_NORMAL_NV, GL_RGB);
	glCombinerOutputNV(GL_COMBINER0_NV, GL_RGB, GL_SPARE0_NV, GL_DISCARD_NV, GL_DISCARD_NV, GL_NONE, GL_NONE, GL_TRUE, GL_FALSE, GL_FALSE);
	
	glFinalCombinerInputNV(GL_VARIABLE_A_NV, GL_SPARE0_NV, GL_UNSIGNED_IDENTITY_NV, GL_RGB);
	glFinalCombinerInputNV(GL_VARIABLE_C_NV, GL_ONE, GL_UNSIGNED_IDENTITY_NV, GL_RGB);
	glFinalCombinerInputNV(GL_VARIABLE_D_NV, GL_TEXTURE1_ARB, GL_UNSIGNED_IDENTITY_NV, GL_RGB);
}
//End of lighting
//This is Vertex Program Stuff. Requires A Geforce card to run. GET ONE NOW!!!
char * GLEngine::openprogram(char * filename)
{
fstream file;
file.open(filename,ios::in|ios::binary);
int sizeoffile=0;
char * program;
file.seekg(0,ios::end);
sizeoffile=file.tellg( );
program=new char[sizeoffile];
file.seekg(0,ios::beg);
file.read(program, sizeoffile );
program[sizeoffile] = 0;
return program;
}

void GLEngine::enablevertexprograms()
{
	glEnable(GL_VERTEX_PROGRAM_NV);
}
void GLEngine::disablevertexprograms()
{
	glDisable(GL_VERTEX_PROGRAM_NV);
}
void GLEngine::enableregistercombiners()
{
	glEnable(GL_REGISTER_COMBINERS_NV);
}
void GLEngine::disableregistercominbers()
{
	glDisable(GL_REGISTER_COMBINERS_NV);
}
void GLEngine::loadvertexprogram(int id,char*filename)
{
	char * vertexp=openprogram(filename);
	glEnable(GL_VERTEX_PROGRAM_NV);

	glGenProgramsNV(1, &vertexprogram[id]);
	glBindProgramNV(GL_VERTEX_PROGRAM_NV, vertexprogram[id]);
	glLoadProgramNV(GL_VERTEX_PROGRAM_NV, vertexprogram[id], strlen(vertexp), (const GLubyte *)vertexp);
   // initialize the vertex program paramter consistently
    // Track the concatenation of the modelview and projection matrix in registers 0-3.
    glTrackMatrixNV( GL_VERTEX_PROGRAM_NV, 0, GL_MODELVIEW_PROJECTION_NV, GL_IDENTITY_NV );
    // Track the modelview matrix in registers 4-7.
    glTrackMatrixNV( GL_VERTEX_PROGRAM_NV, 4, GL_MODELVIEW, GL_IDENTITY_NV );
    // Track the inverse transpose of the modelview matrix in registers 8-11.
    glTrackMatrixNV( GL_VERTEX_PROGRAM_NV, 8, GL_MODELVIEW, GL_INVERSE_TRANSPOSE_NV );
    // Track the inverse modelview matrix in registers 12-15.
    glTrackMatrixNV( GL_VERTEX_PROGRAM_NV, 12, GL_MODELVIEW, GL_INVERSE_NV );
    // c[18]            contains useful constants ( 0.5, 1.0, 2.0, 0.0 )


}
void GLEngine::selectvertexprogram(int selectp)
{
	glBindProgramNV(GL_VERTEX_PROGRAM_NV, vertexprogram[selectp]);
}
#define PI 3.141592654
#define TWOPI 6.283185308
void GLEngine::drawsky()
{
	//////
	//////
    combinercode();
    glEnable(GL_REGISTER_COMBINERS_NV);
	glEnable(GL_BLEND);

	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_LIGHTING);
	glScalef(15,15,15);
	glTranslatef(0,-.50,0);
//	glRotatef(180,1,0,0);
	float ascale=1.002;
	float alphablend=1;

	for(int i2=0;i2<25;i2++)
	{

	glScalef(ascale,ascale,ascale);
	glBegin(GL_TRIANGLES);
	glColor4f(1,1,1,mf1d[i2]);
	for(int i=0;i<4560;i++)
	{
			
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,sphere[i].u*2,sphere[i].v*2);
		glVertex3f(sphere[i].x,sphere[i].y,sphere[i].z);
		
	}
	//////////
	glEnd();

	}
/*
	ascale=.996;
	for( i2=0;i2<15;i2++)
	{
	glScalef(ascale,ascale,ascale);
	glBegin(GL_TRIANGLES);
	glColor4f(1,1,1,mf1d[i2]);
	for(int i=0;i<4560;i++)
	{
			
		glMultiTexCoord2fARB(GL_TEXTURE0_ARB,sphere[i].u*2,sphere[i].v*2);
		glVertex3f(sphere[i].x,sphere[i].y,sphere[i].z);
		
	}
	//////////
	glEnd();

	}*/
	glEnable(GL_CULL_FACE);
	glCullFace(GL_FRONT);
	glEnable(GL_LIGHTING);

	glDisable(GL_REGISTER_COMBINERS_NV);
	glDisable(GL_BLEND);
}
void GLEngine::drawsea()
{
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_LIGHTING);
	glScalef(15,15,15);
	glTranslatef(0,-.50,0);
	glBegin(GL_TRIANGLES);
	glColor4f(1,1,1,1);
	for(int i=0;i<4560;i++)
	{
			
		glTexCoord2f(sphere[i].u*2,sphere[i].v*2);
		glVertex3f(sphere[i].x,sphere[i].y,sphere[i].z);
		
	}
	//////////
	glEnd();
	//	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glDisable(GL_BLEND);
}
void GLEngine::creategrassfromfractal()
{
	for(int y=0;y<SIZEOF_LANDY;y++)
		for(int x=0;x<SIZEOF_LANDX;x++)
		{
			int testit=rand()%2;
			if(testit==0)
			{
				ptexture[y][x][0]=1;
				ptexture[y][x][1]=1;
				ptexture[y][x][2]=1;
				ptexture[y][x][3]=1;
			}
			else
			{
				ptexture[y][x][0]=.5;
				ptexture[y][x][1]=.5;
				ptexture[y][x][2]=.5;
				ptexture[y][x][3]=1;
			}
		}
}
void GLEngine::createsea()
{
for(int y=0;y<SIZEOF_LANDY;y++)
for(int x=0;x<SIZEOF_LANDX;x++)
{
seatexture[y][x][0]=0;
seatexture[y][x][1]=0;
seatexture[y][x][2]=1;
seatexture[y][x][3]=.5;
}
}


void GLEngine::createskyformfractal()
{
	for(int y=0;y<SIZEOF_LANDY;y++)
	{
		for(int x=0;x<SIZEOF_LANDX;x++)
		{
			//
			if(mf[y][x]>0)
			{
				skytexture[y][x][0]=(mf[y][x]);
				skytexture[y][x][1]=(mf[y][x]);
				skytexture[y][x][2]=(mf[y][x]);
				skytexture[y][x][3]=(mf[y][x])/10;
			}
			else
			{	skytexture[y][x][0]=0;
				skytexture[y][x][1]=0;
				skytexture[y][x][2]=1;
				skytexture[y][x][3]=0;
			}
			///
		}
	}

//	glNewList(99999,GL_COMPILE_AND_EXECUTE);
//	glEndList();
}

vertex GLEngine::multiplybymatrix(Matrix multim,vertex vector)
{
vertex tempvertex;
tempvertex.x=multim.x1*vector.x+multim.y1*vector.y+multim.z1*vector.z+multim.w1;
tempvertex.y=multim.x2*vector.x+multim.y2*vector.y+multim.z2*vector.z+multim.w2;
tempvertex.z=multim.x3*vector.x+multim.y3*vector.y+multim.z3*vector.z+multim.w3;
//tempvertex.w=multim.x4*vector.x+multim.y4*vector.y+multim.z4*vector.z+multim.w4;
return tempvertex;
}
///Camera Code
void GLEngine::turn(float x)
{
	g_ViewAngle+=(x*0.017453292519943295769236907684886);

	eyeVX=sin(g_ViewAngle);
	eyeVZ=cos(g_ViewAngle);
	lookDir.x=((eyeVX*2+eye.x));
	lookDir.z=((eyeVZ*2+eye.z));
}
void GLEngine::move(float x)
{

	eye.x+=eyeVX*x;
	eye.y+=eyeVY*x;
	eye.z+=eyeVZ*x;
	lookDir.x+=eyeVX*x;
	lookDir.y+=eyeVY*x;
	lookDir.z+=eyeVZ*x;

}
void GLEngine::climb(float x)
{
	eye.y+=x;
	lookDir.y+=x;
}
void GLEngine::lookup(float x)
{

	g_ViewAnglez+=(x*0.017453292519943295769236907684886);
	eyeVY=tan(g_ViewAnglez);
	//eyeVZ=sin(g_ViewAnglez);
	lookDir.y=((eye.y+eyeVY*2));
	//lookDir.z=((eye.z+eyeVZ*2));*/
/*vertex tempLookDir;
vertex roatedvector;
tempLookDir.x=lookDir.x-eye.x;
tempLookDir.y=lookDir.y-eye.y;
tempLookDir.z=lookDir.z-eye.z;

//
Matrix rotationmatrix={1,0,0,0,
					   0,cos(g_ViewAnglez*1.1),-sin(g_ViewAnglez*1.1),0,
					   0,sin(g_ViewAnglez*1.1),cos(g_ViewAnglez*1.1),0,
					   0,0,0,1};
roatedvector=multiplybymatrix(rotationmatrix,tempLookDir);
lookDir.x=roatedvector.x+eye.x;
lookDir.y=roatedvector.y+eye.y;
lookDir.z=roatedvector.z+eye.z;*/
}

void GLEngine::updatecamera()
{
	glLoadIdentity();
	gluLookAt(eye.x, eye.y, eye.z,
		lookDir.x, lookDir.y, lookDir.z,
		0,1,0);
}
