/* Copyright (c) Jesse Laeuchli 2000. */

class snowp:public particle{
public:
	void update();
	void setupp();
	snowp(){setupp();};
};
void snowp::setupp()
{
	startx=0;
	starty=2;
	startz=-5;
	slowdown=.05;
	for(int i=0;i<numofpart;i++)
	{
		prt[i].fade=1;
		prt[i].speedx=0;
		prt[i].speedy=(randvar(1)/5);
		prt[i].speedz=0;
		prt[i].xg=0;
		prt[i].yg=-.8;
		prt[i].zg=0;
		prt[i].xp=startx+(randvar2(1)/10);//+=(randvar(1)/100);//randvar(1);
		prt[i].yp=starty+(randvar(1)/50);//+=(randvar(1)/100);
		prt[i].zp=startz+(randvar(1));//+=(randvar(1)/100);
	}
}
void snowp::update()
{
	for(int i=0;i<numofpart;i++)
	{
		if(prt[i].yp>-5)
		{
			prt[i].xp+=prt[i].speedx;
			prt[i].yp+=prt[i].speedy;
			prt[i].zp+=prt[i].speedz;
			if(prt[i].speedx!=0)
			{
				prt[i].speedx-=slowdown;
			}
			if(prt[i].speedy!=0)
			{
				prt[i].speedy-=slowdown;
			}
			if(prt[i].speedz!=0)
			{
				prt[i].speedz-=slowdown;
			}
			prt[i].zp+=prt[i].zg;
			prt[i].yp+=prt[i].yg;
			prt[i].xp+=prt[i].xg;
			prt[i].fade-=slowdown;
		}
		else
		{
			prt[i].fade=1;
			prt[i].speedx=0;
			prt[i].speedy=(randvar(1)/5);
			prt[i].speedz=0;
			prt[i].xg=0;
			prt[i].yg=-.8;
			prt[i].zg=0;
			prt[i].xp=startx+(randvar2(1)/10);//+=(randvar(1)/100);//randvar(1);
			prt[i].yp=starty+(randvar(1)/50);//+=(randvar(1)/100);
			prt[i].zp=startz+(randvar(1));//+=(randvar(1)/100);
		}
	}
}