
class SShip{
public:
	char shipnetworkinfo[40];
	float xangle;
	float yangle;
	float zangle;
////////This is to store the network information of each ship. Call ParseInfo to populate these variables.	
	char posx[6];
	char posy[6];
	char posz[6];
	char anglex[3];
	char angley[3];
	char anglez[3];
////////
	float speedx;
	float speedy;
	float speedz;

	float speed;

	float action;

	float topx;
	float topy;
	float topz;
	SShip(GLEngine*shipgraphics,char *shipfile,char *shiptexture,int textureid,int multitextureid, int objectid);//only one texture per ship right now :-(. Later this function will support more, and shaders, and info for particles systems.
	void DrawShip();
	void UpDatePostion();
	void ParseInfo();
private:
	SSHip();
	void SetupSpeed();
	int ido;
	int idt;
	int midt;
	float postionx;
	float postiony;
	float postionz;
	void TopSpeed();

	GLEngine*SShipgraphics;
};
SShip::SShip(GLEngine*shipgraphics,char *shipfile,char *shiptexture,int textureid,int multitextureid, int objectid )
{
shipgraphics->load3dfile(shipfile,objectid);
shipgraphics->loadtexture(shiptexture,textureid);
shipgraphics->loadtexture("patch.bmp",multitextureid);
midt=multitextureid;


ido=objectid;
idt=textureid;
xangle=-80;
yangle=0;
zangle=0;
postionx=0;
postiony=0;
postionz=-6;
speedx=0;
speedy=0;
speedz=0;
action=0;
speed=0;
topx=.4;
topy=3;
topz=1;
SShipgraphics=shipgraphics;
}
void SShip::SetupSpeed()
{
if(speed!=0)
{
if(xangle>=-80)
{
float temp=xangle-10;
float percentagex=0;
float percentagez=0;
if(temp!=0)
{
percentagex=temp/90;
}
percentagex=-percentagex;
percentagez=1-percentagex;
if(percentagex!=0)
{
speedx=speed*percentagex;
}
if(percentagez!=0)
{
speedz=speed*-percentagez;
}
}
else
if(xangle<=-80)
{
	///////////////
float temp=(xangle-10)+90;
float percentagex=0;
float percentagez=0;
if(temp!=0)
{
percentagez=(temp/90);
}
percentagez=(percentagez)+1;
percentagex=1-percentagez;
if(percentagex!=0)
{
speedz=speed*percentagex;
}
if(percentagez!=0)
{
speedx=speed*percentagez;
}
}
//////////
}
}
void SShip::DrawShip()
{
glPushMatrix();
glDisable(GL_LIGHTING);
glLoadIdentity();
glScalef(.0001,.0001,.0001);
glTranslatef(0,0,-6000);
glRotatef(xangle,1,0,0);
glRotatef(zangle,0,1,0);
//glRotatef(yangle,0,0,1);


SShipgraphics->enablemultitextureunit(0);
SShipgraphics->selecttexture(idt);
SShipgraphics->enablemultitextureunit(1);
glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_ADD);
SShipgraphics->selecttexture(midt);
SShipgraphics->drawfile(ido);
SShipgraphics->enablemultitextureunit(0);

glEnable(GL_LIGHTING);

glPopMatrix();
}
void SShip::TopSpeed()
{
if(speedx>topx)
{
speedx=topx;
}
if(speedy>topy)
{
speedy=topy;
}
if(speedz>topz)
{
speedz=topz;
}
if(speedx<-topx)
{
speedx=-topx;
}
if(speedy<-topy)
{
speedy=-topy;
}
if(speedz<-topz)
{
speedz=-topz;
}
}
void SShip::UpDatePostion()
{
SetupSpeed();
TopSpeed();
postionx+=speedx;
postiony+=speedy;
postionz+=speedz;
ParseInfo();
}
void SShip::ParseInfo()
{

	_gcvt(SShipgraphics->eye.x,6,posx);
	_gcvt(SShipgraphics->eye.y,6,posy);
	_gcvt(SShipgraphics->eye.z,6,posz);
	int tempx;
	int tempy;
	int tempz;

	SShipgraphics->file2<<"x:"<<posx<<endl;
	SShipgraphics->file2<<"y:"<<posy<<endl;
	SShipgraphics->file2<<"z:"<<posz<<endl;
}